package de.intevation.flys.importer;

import java.util.List;

import java.math.BigDecimal;

import de.intevation.flys.model.MainValue;
import de.intevation.flys.model.Gauge;
import de.intevation.flys.model.River;
import de.intevation.flys.model.NamedMainValue;

import org.hibernate.Session;
import org.hibernate.Query;

public class ImportMainValue
{
    protected ImportGauge          gauge;
    protected ImportNamedMainValue mainValue;
    protected BigDecimal           value;

    protected MainValue peer;

    public ImportMainValue() {
    }

    public ImportMainValue(
        ImportGauge          gauge,
        ImportNamedMainValue mainValue,
        BigDecimal           value
    ) {
        this.gauge     = gauge;
        this.mainValue = mainValue;
        this.value     = value;
    }

    public ImportGauge getGauge() {
        return gauge;
    }

    public void setGauge(ImportGauge gauge) {
        this.gauge = gauge;
    }

    public ImportNamedMainValue getMainValue() {
        return mainValue;
    }

    public void setMainValue(ImportNamedMainValue mainValue) {
        this.mainValue = mainValue;
    }

    public BigDecimal getValue() {
        return value;
    }

    public void setValue(BigDecimal value) {
        this.value = value;
    }

    public MainValue getPeer(River river) {
        if (peer == null) {
            Session session = ImporterSession.getInstance().getDatabaseSession();
            Query query = session.createQuery("from MainValue where "
                + "gauge.id=:gauge_id and mainValue.id=:name_id "
                + "and value=:value");
            Gauge          g = gauge.getPeer(river);
            NamedMainValue n = mainValue.getPeer();
            query.setParameter("gauge_id", g.getId());
            query.setParameter("name_id",  n.getId());
            query.setParameter("value",    value);
            List<MainValue> values = query.list();
            if (values.isEmpty()) {
                peer = new MainValue(g, n, value, null);
                session.save(peer);
            }
            else {
                peer = values.get(0);
            }
        }
        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
